#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <Xm/Scale.h>
#include <Xm/RowColumn.h>
#include <Xm/PushB.h>

int Channels[8];


void NewValue ( Widget scaleW , XtPointer client_data , XtPointer call_data )
{
   /*************/

   int Chan = (int)client_data;
   XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct*) call_data;
   int data = 0x1000 - cbs->value;
 

   write ( Channels[Chan] , &data , 2 );

}


void SetUpChannels ()
{
   int i;
   char Name[128];
   for ( i = 0 ; i < 8 ; i ++ )
   {
	   sprintf ( Name,  "../../Display/Display/Driver/dev/dacD%d" , i );
	   if ( 2 > 
     		(Channels[i] = open (Name,O_WRONLY )))
	    {
		printf ( "Error opening %s \n" , Name );    
		exit ( 0 );    
            };
	     

   }

}

void main ( int argc , char ** argv )
{
    Widget toplevel, rowcol , scale;
    XtVarArgsList  argList;
    XtAppContext app;
    char Name[128];
    int i;

    SetUpChannels ();

    XtSetLanguageProc ( NULL,NULL,NULL);

    toplevel = XtVaAppInitialize ( &app , "Hello" , NULL , 0, 
		&argc , argv , NULL , NULL );

    rowcol = XtVaCreateManagedWidget ( "rowcol" , xmRowColumnWidgetClass,
	     toplevel , XmNorientation , XmHORIZONTAL , NULL );

    argList = XtVaCreateArgsList ( NULL , XmNshowValue , TRUE , 
		    			 XmNmaximum   , 0xfff ,
					 XmNminimum   , - 0xfff,
					 XmNscaleMultiple, 5 ,
					 NULL );

    for ( i = 0 ; i < 8 ; i ++ )
    {
        sprintf ( Name , "Chan %d" , i );
	
        scale = XtVaCreateManagedWidget ( "Name" , xmScaleWidgetClass,
	              rowcol , XtVaNestedList , argList ,
	     	      XtVaTypedArg, XmNtitleString , XmRString , Name , 
		      					strlen(Name)+1,
	              NULL );

	XtAddCallback ( scale , XmNvalueChangedCallback , 
				NewValue , (XtPointer) i );
	XtAddCallback ( scale , XmNdragCallback , 
				NewValue , (XtPointer)i );
    }
   
    XtFree          ( argList  );
    XtManageChild   ( rowcol   );
    XtRealizeWidget ( toplevel );
    XtAppMainLoop   ( app      );
}
